import mqtt from 'mqtt';
export interface EventHook {
    runEvent: (clientID: string, topic: string, message: string, packet?: mqtt.IPublishPacket) => void;
    unRegisterEvent: (clientID: string, topic: string, vm?: any) => Promise<void>;
    registerEvent: (clientID: string, topic: string, callback: (topic: string, message: string) => void, vm?: string) => Promise<void>;
    clearEvent: (clientID: string) => Promise<void>;
}
export interface Listener {
    callback: (topic: string, message: string, packet?: mqtt.IPublishPacket) => void;
    vm: string;
}
export declare const useEventHook: () => EventHook;
